#include "core/cpu/cpu.h"
#include "core/gpio/gpio.h"
#include "core/systick/systick.h"


int main (void)
{
	// Initialise the cpu
	cpuInit();	
	// Initialise the systick timer with one tick every 10 millaseconds
	systickInit(10);
	gpioInit();
	// Set GPIO0.7 to output
	gpioSetDir(0, 7, gpioDirection_Output);
	// Disable the internal pullup/down resistor on P0.7
	gpioSetPullup(&IOCON_PIO0_7, gpioPullupMode_Inactive);
	
	while (1) {
		// Set GPIO0.7 high
		gpioSetValue(0, 7, 1);
		systickDelay(50);
		// Set GPIO0.7 low
		gpioSetValue(0, 7, 0);
		systickDelay(50);
	}
}