#include "core/cpu/cpu.h"
#include "core/uart/uart.h"
#include "core/usbcdc/usb.h"
#include "core/usbcdc/usbcore.h"
#include "core/usbcdc/usbhw.h"
#include "core/usbcdc/cdcuser.h"

/* Systick Timer Settings */
#define CFG_SYSTICK_DELAY_IN_MS     (1)           // The number of milliseconds between each tick of the systick timer
/* UART Settings */
#define CFG_UART_BAUDRATE           (57600)       // Default UART speed
#define CFG_UART_BUFSIZE            (80)          // RX FIFO buffer size (the maximum number of received chars to store)

// loop until any key input.
void waitUntilAnyKeyInput() {	
	int numAvailByte = 0;
	do {
		CDC_OutBufAvailChar (&numAvailByte);
	} while(numAvailByte == 0);
}

int main (void)
{
	// Initialise the cpu
	cpuInit();	

    // Initialise UART with the default baud rate (set in projectconfig.h)
    uartInit(CFG_UART_BAUDRATE);

	// Initialise USB CDC
    CDC_Init();                   // Initialise VCOM
    USB_Init();                   // USB Initialization
    USB_Connect(TRUE);            // USB Connect
    while (!USB_Configuration);   // wait until USB is configured	
	
	waitUntilAnyKeyInput();
	
	printf("Hello world");
	
	while (1) ;
}