#include "core/cpu/cpu.h"
#include "core/gpio/gpio.h"


int main (void)
{
	// Initialise the cpu
	cpuInit();	
	gpioInit();
	
	// Set GPIO0.7 to output
	gpioSetDir(0, 7, gpioDirection_Output);
	// Disable the internal pullup/down resistor on P0.7
	gpioSetPullup(&IOCON_PIO0_7, gpioPullupMode_Inactive);
	
	// Set GPIO2.4 to input
	gpioSetDir(2, 4, gpioDirection_Input);
	// Enable the pull-down resistor on GPIO2.4 
	gpioSetPullup (&IOCON_PIO2_4, gpioPullupMode_PullDown);
	
	while (1) {
		// Read the current state of GPIO2.4 (1 = high, 0 = low)
		if (gpioGetValue(2, 4) != 0) {
			// Set GPIO0.7 high
			gpioSetValue(0, 7, 1);
		}
		else {
			// Set GPIO0.7 low
			gpioSetValue(0, 7, 0);
		}
	}
}